package com.winhc.phoenix.example.configuration;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

import java.util.LinkedHashMap;
import java.util.Map;

/**
 * @author: XuJiakai
 * 2021/8/4 10:50
 */
@Slf4j
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@Component
@ConfigurationProperties(prefix = DynamicElasticSearchProperties.PREFIX)
public class DynamicElasticSearchProperties {
    public static final String PREFIX = "winhc.dynamic.elasticsearch";

    /**
     * 必须设置默认的库,默认master
     */
    private String primary = "master";

    /**
     * 是否启用严格模式,默认不启动. 严格模式下未匹配到数据源直接报错, 非严格模式下则使用默认数据源primary所设置的数据源
     */
    private Boolean strict = false;

    private Map<String, ElasticSearchRestClientProperties> rest = new LinkedHashMap<>();
}
