package com.winhc.phoenix.example.configuration;

import lombok.Getter;
import lombok.Setter;
import lombok.extern.slf4j.Slf4j;

import java.time.Duration;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * @author: XuJiakai
 * 2021/8/4 10:52
 */
@Slf4j
@Getter
@Setter
public class ElasticSearchRestClientProperties {
    /**
     * Comma-separated list of the Elasticsearch instances to use.
     */
    private List<String> uris = new ArrayList<>(Collections.singletonList("http://localhost:9200"));

    /**
     * Credentials username.
     */
    private String username;

    /**
     * Credentials password.
     */
    private String password;

    /**
     * Connection timeout.
     */
    private Duration connectionTimeout = Duration.ofSeconds(100);

    /**
     * Read timeout.
     */
    private Duration readTimeout = Duration.ofSeconds(300);
}
