package com.winhc.phoenix.example.configuration;

import com.aliyun.odps.Odps;
import com.aliyun.odps.account.Account;
import com.aliyun.odps.account.AliyunAccount;
import lombok.AllArgsConstructor;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

/**
 * @Author: XuJiakai
 * @Date: 2020/9/17 14:55
 * @Description:
 */
@Configuration
@AllArgsConstructor
public class OdpsConfiguration {
    private final DataWorksAccessProperties project;
    private static final String endPoint = "http://service.odps.aliyun.com/api";

    @Bean
    public Odps odps() {
        Account account = new AliyunAccount(project.getAccessKeyId(), project.getAccessKeySecret());
        Odps odps = new Odps(account);
        odps.setEndpoint(endPoint);
        odps.setDefaultProject("winhc_eci_dev");
        return odps;
    }

}
