package com.winhc.phoenix.example.controller;

import com.winhc.phoenix.example.service.InnerSearchCompanyService;
import io.swagger.annotations.Api;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author: XuJiakai
 * 2021/4/23 19:08
 */
@Slf4j
@AllArgsConstructor
@RestController
@Api(tags = "内部搜索", value = "inner")
@RequestMapping("inner")
public class InnerSearchCompanyController {
    private final InnerSearchCompanyService innerSearchCompanyService;

    @GetMapping("query-company")
    public Object query(@RequestParam String companyName){
        return innerSearchCompanyService.searchCompanyName(companyName);
    }
}
