package com.winhc.phoenix.example.controller;

import cn.hutool.extra.servlet.ServletUtil;
import com.winhc.phoenix.example.aspect.Timer;
import com.winhc.phoenix.example.service.JudgmentDocumentsService;
import com.winhc.phoenix.example.vo.judgment.JudgmentDocumentsSearchContent;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;

/**
 * @author: XuJiakai
 * 2022/7/29 14:38
 */
@Slf4j
@AllArgsConstructor
@RestController
@Api(tags = "文书查询", value = "judgment")
@RequestMapping("judgment")
public class JudgmentDocumentsController {
    private HttpServletRequest request;


    private final JudgmentDocumentsService judgmentDocumentsService;

    @Timer
    @ApiOperation(value = "文书查询")
    @PostMapping("query")
    public Object query(@RequestBody JudgmentDocumentsSearchContent content) {
        String clientIP = ServletUtil.getClientIP(request);
        content.setIp(clientIP);
        return judgmentDocumentsService.search(content);
    }

}
