package com.winhc.phoenix.example.controller;

import com.winhc.phoenix.example.service.WinhcKafkaService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.AllArgsConstructor;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.web.bind.annotation.*;

/**
 * @author: XuJiakai
 * 2020/12/21 19:17
 */
@RestController
@AllArgsConstructor
@Api(tags = "kafka测试接口", value = "kafka")
@RequestMapping("kafka")
@ConditionalOnProperty(value = "spring.profiles.active", havingValue = "prod", matchIfMissing = true)
public class KafkaController {
    private final WinhcKafkaService kafkaService;

    @ApiOperation(value = "发送消息")
    @PostMapping("{topic}")
    public Object send(@PathVariable String topic, @RequestBody String body) {
        return kafkaService.send(topic, body);
    }

    @ApiOperation(value = "接收消息（不允许大量请求）")
    @GetMapping("{topic}")
    public Object get(@PathVariable String topic,@RequestParam(defaultValue = "1") Integer maxSize) {
        return kafkaService.getMsg(topic,maxSize);
    }
}
