package com.winhc.phoenix.example.controller;

import com.winhc.phoenix.example.service.SmsService;
import com.winhc.phoenix.example.vo.ResponseVo;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.util.Assert;
import org.springframework.web.bind.annotation.*;

/**
 * @author: XuJiakai
 * 2020/10/31 10:53
 */
@Slf4j
@RestController
@RequestMapping("sms")
@AllArgsConstructor
public class SmsController {
    private final SmsService smsService;

    private static final String TOKEN = "ansdvhhanvisdnhacamjklvrvrsjka";

    @PostMapping("send")
    public ResponseVo send(@RequestParam String sign, @RequestBody String smsBean) {
        log.info(smsBean);
        long start = System.currentTimeMillis();
        try {
            Assert.isTrue(TOKEN.equals(sign),"验签不通过！");
            log.info("验签通过！");
            return ResponseVo.success(start, smsService.send(smsBean));
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            return ResponseVo.failure(start, e.getMessage());
        }
    }
}
