package com.winhc.phoenix.example.dao;

import lombok.SneakyThrows;
import org.elasticsearch.index.query.QueryBuilder;
import org.elasticsearch.search.builder.SearchSourceBuilder;
import org.elasticsearch.search.fetch.subphase.FetchSourceContext;
import org.elasticsearch.search.rescore.QueryRescorerBuilder;
import org.elasticsearch.search.sort.SortBuilder;

import java.util.List;

/**
 * @author: XuJiakai
 * 2020/11/20 15:15
 */
public interface SearchDao {

    Object search(String index, String type, QueryBuilder query, SortBuilder sortBuilder, FetchSourceContext fetchSourceContext, int from, int size);

    Object search(String index, String type, QueryBuilder query, int from, int size);

    Object search(String index, String type, QueryBuilder query, List<QueryRescorerBuilder> rescoreBuilder, SortBuilder sortBuilder, FetchSourceContext fetchSourceContext, int from, int size, String preference);

    Object search(String index, String type, QueryBuilder query, List<QueryRescorerBuilder> rescoreBuilder, List<SortBuilder> sortBuilder, FetchSourceContext fetchSourceContext, int from, int size, String preference,List<String> highlightField);

    @SneakyThrows
    Object search(String index, String type, SearchSourceBuilder searchSourceBuilder);

    boolean deleteByIds(String index, String type, List<String> ids);

}
