/*
package com.winhc.phoenix.example.job;

import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.mongodb.client.MongoCollection;
import lombok.AllArgsConstructor;
import lombok.SneakyThrows;
import lombok.extern.slf4j.Slf4j;
import org.bson.Document;
import org.elasticsearch.action.search.SearchRequest;
import org.elasticsearch.action.search.SearchResponse;
import org.elasticsearch.client.RestHighLevelClient;
import org.elasticsearch.index.query.BoolQueryBuilder;
import org.elasticsearch.index.query.QueryBuilders;
import org.elasticsearch.search.aggregations.AggregationBuilders;
import org.elasticsearch.search.aggregations.metrics.sum.SumAggregationBuilder;
import org.elasticsearch.search.builder.SearchSourceBuilder;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.stereotype.Component;

import java.util.*;

import static com.winhc.phoenix.example.util.MaxBatchQueryUtils.addTerms;
*/
/**
 * @author: XuJiakai
 * 2021/3/1 09:43
 *//*

@Slf4j
@Component
@AllArgsConstructor
public class BatchQueryEsTest {

    private ObjectMapper mapper;
    private RestHighLevelClient restHighLevelClient;
    private final MongoTemplate mongoTemplate;

    private static final TypeReference<HashMap<String, Object>> typeRef
            = new TypeReference<HashMap<String, Object>>() {
    };

    public void start(int batchSize, int round) {
        MongoCollection<Document> company_id = mongoTemplate.getCollection("xjk_test_es_company_id");
        Set<String> set = new HashSet<String>();

        for (Document doc : company_id.find().skip(batchSize * (round - 1)).batchSize(batchSize)) {
            String id = doc.getString("_id");
            set.add(id);

            if (set.size() >= batchSize) {
                break;
            }
        }

        Object query = query2(set);
        System.out.println();
        System.out.println(query);
        System.out.println();
    }


    @SneakyThrows
    private Object query2(Set<String> ids) {
        log.info("start... size: {}", ids.size());

        BoolQueryBuilder boolQuery = QueryBuilders.boolQuery();

        boolQuery.filter(addTerms(ids, "_id"));

        List<SumAggregationBuilder> list = Arrays.asList(
                AggregationBuilders.sum("open_announcement_1").field("summary.company_court_open_announcement_deleted_0_defendant")
        );


        SearchSourceBuilder searchSourceBuilder = new SearchSourceBuilder()
                .query(boolQuery)
                .size(0);

        for (SumAggregationBuilder builder : list) {
            searchSourceBuilder.aggregation(builder);
        }


        SearchRequest searchRequest = new SearchRequest()
                .indices("out_es_summary_v1")
                .types("doc")
                .source(searchSourceBuilder);
        log.info("start!");
        SearchResponse search = restHighLevelClient.search(searchRequest);
        log.info("end!");
        return mapper.readValue(search.toString(), typeRef);
    }


    @SneakyThrows
    private Object query(Set<String> ids) {
        log.info("start... size: {}", ids.size());

        BoolQueryBuilder boolQuery = QueryBuilders.boolQuery();

        boolQuery.must(addTerms(ids, "defendant_info.litigant_id"));
        boolQuery.must(addTerms(ids, "plaintiff_info.litigant_id"));
        boolQuery.filter(QueryBuilders.termQuery("deleted", "0"));

        SearchSourceBuilder searchSourceBuilder = new SearchSourceBuilder()
                .query(boolQuery)
                .size(0);

        SearchRequest searchRequest = new SearchRequest()
                .indices("winhc_index_company_court_open_announcement_v1")
                .types("doc")
                .source(searchSourceBuilder);
        log.info("start!");
        SearchResponse search = restHighLevelClient.search(searchRequest);
        log.info("end!");
        return mapper.readValue(search.toString(), typeRef);
    }

}
*/
