package com.winhc.phoenix.example.job;

import com.mongodb.client.MongoCollection;
import com.winhc.phoenix.example.configuration.DynamicElasticSearchClient;
import com.winhc.phoenix.example.framework.es.EsFastScan;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.bson.Document;
import org.elasticsearch.client.RestHighLevelClient;
import org.elasticsearch.search.SearchHit;
import org.springframework.data.mongodb.core.MongoTemplate;
import org.springframework.stereotype.Component;

import java.util.Arrays;
import java.util.List;
import java.util.function.Consumer;
import java.util.stream.Collectors;

/**
 * @author: XuJiakai
 * 2020/11/16 20:03
 */
@Slf4j
@Component
@AllArgsConstructor
public class EsScanJob {

    private final DynamicElasticSearchClient dynamicElasticSearchClient;
    private final MongoTemplate mongoTemplate;

    public void start() {
    }


    public void fixBugByDeleted(String dsl, String tn) {
        MongoCollection<Document> person = mongoTemplate.getCollection("a_xjk_hk_deleted_id_20211216");
        Consumer<SearchHit[]> func = list -> {
            List<Document> li = Arrays.stream(list).map(d -> {
                String id = d.getId();
                Document document = new Document();
                document.put("_id", id);
                return document;
            }).collect(Collectors.toList());
            person.insertMany(li);
        };
        RestHighLevelClient restHighLevelClient = dynamicElasticSearchClient.getRestHighLevelClient();
        new EsFastScan(restHighLevelClient, func, "winhc_index_" + tn + "_v1", "_doc", dsl).scan();
    }

    public void fixBugByDeleted(String tn) {
        String dsl = "{\n" +
                "  \"query\": {\n" +
                "    \"bool\": {\n" +
                "      \"must\": [\n" +
                "        {\n" +
                "          \"term\": {\n" +
                "            \"company_type\": {\n" +
                "              \"value\": \"2\"\n" +
                "            }\n" +
                "          }\n" +
                "        },{\n" +
                "          \"terms\": {\n" +
                "            \"deleted\": [\n" +
                "              \"0\",\n" +
                "              \"1\"\n" +
                "            ]\n" +
                "          }\n" +
                "        }\n" +
                "      ]\n" +
                "    }\n" +
                "  }\n" +
                "}";

        fixBugByDeleted(dsl, tn);

    }

}
