package com.winhc.phoenix.example.job;

import com.winhc.phoenix.example.configuration.HbaseConfiguration;
import com.winhc.phoenix.example.framework.hbase.HbaseFastScan;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.apache.hadoop.hbase.client.Connection;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;
import java.util.function.Consumer;
import java.util.stream.Collectors;

/**
 * @author: XuJiakai
 * 2020/11/16 14:33
 */
@Slf4j
@Component
@AllArgsConstructor
public class HbaseScanJob {
    private final Connection connection;
    private final HbaseConfiguration hbaseConfiguration;

    public void start() {
        Consumer<List<Map<String, String>>> func = list -> {
            List<String> cids = list.stream().map(d -> d.get("rowkey")).collect(Collectors.toList());
            System.out.println(cids);
        };

        new HbaseFastScan(hbaseConfiguration::connection, "COMPANY_TAX_CONTRAVENTION", func).scan();
    }
}
