package com.winhc.phoenix.example.service.impl;

import com.winhc.phoenix.example.scheduled.TaskStatusScheduled;
import com.winhc.phoenix.example.service.TaskService;
import com.winhc.phoenix.example.task.AsyncTask;
import lombok.AllArgsConstructor;
import lombok.extern.slf4j.Slf4j;

import java.util.concurrent.Future;

/**
 * @author: XuJiakai
 * 2021/5/18 13:51
 */
@Slf4j
//@Service
@AllArgsConstructor
public class TaskServiceImpl implements TaskService {
    private final AsyncTask asyncTask;
    private final TaskStatusScheduled taskStatusScheduled;

    @Override
    public synchronized String pullCreditPunishmentTouch() {
        if (!taskStatusScheduled.isIdle()) {
            return "任务队列中有未完成的任务，请务重复调用！";
        }
        Future<Boolean> booleanFuture = asyncTask.pullCreditPunishmentTouch();
        taskStatusScheduled.put(booleanFuture);
        return "ok";
    }
}
