package com.winhc.phoenix.example.util;


import lombok.SneakyThrows;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.time.Instant;
import java.time.ZoneId;
import java.time.format.DateTimeFormatter;
import java.time.temporal.ChronoUnit;
import java.util.Date;
import java.util.Locale;

/**
 * @Author: XuJiakai
 * @Date: 2020/7/20 13:48
 * @Description:
 */
public class DateUtils {
    private static final ThreadLocal<DateFormat> localDateFormat = ThreadLocal.withInitial(() -> new SimpleDateFormat("yyyy-MM-dd HH:mm:ss"));

    private static final DateTimeFormatter df = DateTimeFormatter.ofPattern("yyyy-MM-dd")
            .withLocale(Locale.CHINA)
            .withZone(ZoneId.systemDefault());
    private static final DateTimeFormatter ymd_df = DateTimeFormatter.ofPattern("yyyyMMdd")
            .withLocale(Locale.CHINA)
            .withZone(ZoneId.systemDefault());

    private static final DateTimeFormatter dateFormatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss")
            .withLocale(Locale.CHINA)
            .withZone(ZoneId.systemDefault());

    public static String getYesterday() {
        Instant instant = Instant.now().minus(1, ChronoUnit.DAYS);
        return df.format(instant);
    }

    public static String getYesterday_ymd() {
        Instant instant = Instant.now().minus(1, ChronoUnit.DAYS);
        return ymd_df.format(instant);
    }

    public static String getMinusDay(Integer i) {
        Instant instant = Instant.now().minus(i, ChronoUnit.DAYS);
        return df.format(instant);
    }

    @SneakyThrows
    public static Date toDate(String s) {
        return localDateFormat.get().parse(s);
    }


    public static void main(String[] args) {
        System.out.println(toDate("2021-12-20 12:21:59"));

    }
}
