package com.winhc.phoenix.example.util;

import org.apache.hadoop.hbase.Cell;
import org.apache.hadoop.hbase.client.Result;
import org.apache.hadoop.hbase.util.Bytes;

import java.util.HashMap;
import java.util.Map;

/**
 * @Author: XuJiakai
 * @Date: 2020/9/2 17:28
 * @Description:
 */
public class HbaseResultUtils {
    public static Map<String, String> parseResult(Result result) {
        if (result == null || result.isEmpty()) {
            return null;
        }
        Map<String, String> columnMap = new HashMap<>();
        String rowKey = null;
        for (Cell cell : result.listCells()) {
            if (rowKey == null) {
                rowKey = Bytes.toString(cell.getRowArray(), cell.getRowOffset(), cell.getRowLength());
            }
            columnMap.put(Bytes.toString(cell.getQualifierArray(), cell.getQualifierOffset(), cell.getQualifierLength()), Bytes.toString(cell.getValueArray(), cell.getValueOffset(), cell.getValueLength()));
        }
        columnMap.put("rowkey", rowKey);
        return columnMap;
    }
}
