package com.winhc.phoenix.example.util;

import com.alibaba.fastjson.JSONPath;
import com.aliyun.odps.Column;
import com.aliyun.odps.OdpsType;
import com.aliyun.odps.TableSchema;
import org.apache.commons.lang3.StringUtils;

/**
 * @author: XuJiakai
 * 2021/12/20 11:38
 */
public class OdpsTableSchemaUtils {

    public static Object json2Value(Object json, String jsonPath, String key, TableSchema schema) {
        Object o = JSONPath.eval(json, jsonPath);
        if (o instanceof Integer) {
            o = o + "";
        }
        String eval = ((String) o);
        if (StringUtils.isBlank(eval)) {
            return null;
        }
        Column column = schema.getColumn(key);
        OdpsType odpsType = column.getTypeInfo().getOdpsType();
        switch (odpsType) {
            case STRING:
                return ((String) eval);
            case BIGINT:
                return Long.parseLong(eval);
            case DATETIME:
                try {
                    return DateUtils.toDate(eval);
                } catch (Exception e) {
                    return null;
                }
            default:
                throw new RuntimeException("odps type: " + odpsType.name() + " is not found !");
        }
    }
}
