package com.winhc.phoenix.example.util.company.search;

import com.github.houbb.opencc4j.util.ZhConverterUtil;
import org.apache.commons.lang3.StringUtils;
import org.elasticsearch.script.Script;
import org.elasticsearch.script.ScriptType;

import java.util.Map;
import java.util.regex.Pattern;

/**
 * @author: XuJiakai
 * 2021/12/31 11:15
 */
public class CompanyIndexUtils {
    private static final Pattern pattern = Pattern.compile("[^\\u4e00-\\u9fa50-9a-zA-Z]");

    public static String convertToSimplifiedChinese(String val) {
        return StringUtils.isEmpty(val) ? null : ZhConverterUtil.toSimple(val);
    }

    public static String cleanup(String val) {
        return StringUtils.isNotBlank(val) ? pattern.matcher(val).replaceAll("") : "";
    }

    public static Script getScript(String scriptContent, Map<String, Object> map) {
        return new Script(ScriptType.INLINE, "painless", scriptContent, map);
    }

    public static Script getScript(String scriptContent) {
        return getScript(scriptContent, null);
    }
}
