package com.winhc.phoenix.example.util.company.search;

import lombok.*;
import org.apache.commons.lang3.StringUtils;

import java.util.List;
import java.util.regex.Pattern;

/**
 * @author: XuJiakai
 * 2021/11/19 16:56
 */
@Getter
@Setter
@NoArgsConstructor
@AllArgsConstructor
@Builder
public class CompanyQueryVo {
    private String content;

    /**
     * 查询类型，1名称。2法人。3股东or高管。4品牌or产品
     */
    private List<Integer> searchTypeList;


    private static final Pattern pattern = Pattern.compile("[^\\u4e00-\\u9fa50-9a-zA-Z]");


    public String getCleanupContent() {
        return cleanup(content);
    }

    public static String cleanup(String val) {
        return StringUtils.isNotBlank(val) ? pattern.matcher(val).replaceAll("") : "";
    }
}
