package com.winhc.phoenix.example.util.company.search;

import com.hankcs.hanlp.corpus.document.sentence.word.Word;
import com.winhc.tool.nlp.WinhcTokenizer;
import com.winhc.tool.nlp.utils.FamilyNameUtils;
import lombok.extern.slf4j.Slf4j;

import java.io.IOException;
import java.util.List;

/**
 * @author: XuJiakai
 * 2021/12/10 14:27
 */
@Slf4j
public class CompanySearchClassifyUtils {

    private static WinhcTokenizer winhcTokenizer;

    static {
        try {
            winhcTokenizer = WinhcTokenizer.getInstance();
        } catch (IOException exception) {
            throw new RuntimeException(exception);
        }
    }

    public static boolean isPerson(String keyword) {
        try {
            List<Word> analyze = winhcTokenizer.analyze(keyword);
            return analyze.size() == 1 && "nr".equals(analyze.get(0).getLabel()) && FamilyNameUtils.containsFamilyName(keyword);
        } catch (Exception e) {
            log.error(e.getMessage(), e);
            return false;
        }
    }
}
