package com.winhc.phoenix.example.vo.judgment;


import cn.hutool.crypto.SecureUtil;
import lombok.Getter;
import lombok.ToString;

import java.util.List;
import java.util.Map;

/**
 * @author: XuJiakai
 * 2022/7/29 11:43
 */
@Getter
@ToString
public class JudgmentDocumentsSearchContent {
    private int from = 0;
    private int size = 10;

    /**
     * 是否查询权威案例
     */
    private boolean authorityCase = false;

    private String ip;

    public void setIp(String ip) {
        this.ip = ip;
    }

    private Map<String, JudgmentDocumentsSearchType> content;

    /**
     * 法院层级
     */
    private List<CourtLevels> courtLevels;

    /**
     * 筛选：专门法院、审理法院
     */
    private List<String> courtCode;

    /**
     * 筛选：地域
     */
    private List<String> areaCode;

    /**
     * 案由，|分割
     */
    private List<String> caseCause;

    /**
     * 审判程序
     */
    private List<String> judicialProcedure;

    /**
     * 文书性质：判决书、裁定书
     */
    private List<String> documentType;

    /**
     * 审判年份。如果是范围则用  [202101,202201] ,闭区间
     */
    private List<String> judgmentYear;

    /**
     * 文书来源类型：指导性案例、公报案例、普通案例...
     */
    private List<String> documentSourceType;

    /**
     * 审判结果
     */
    private List<String> judgmentResult;

    /**
     * 文章字数。[,100]、[100,200]、[10000,]
     */
    private List<String> wordCount;


    /**
     * 量刑情节。自首、坦白、立功...
     */
    private List<String> sentencingCircumstances;

    /**
     * 争议焦点
     */
    private List<String> disputeFocus;


    /**
     * 案情
     */
    private List<String> caseDetails;


    public String getPreference() {
        return SecureUtil.md5(String.join("", content.keySet()));
    }


    private JudgmentDocumentsSortType sort;

    public boolean isNotSort() {
        return sort != null && sort == JudgmentDocumentsSortType.NOT_SORT;
    }

}
