package com.winhc.phoenix.example.vo.judgment;

import java.util.Arrays;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * @author: XuJiakai
 * 2022/7/29 11:44
 */
@SuppressWarnings("all")
public enum JudgmentDocumentsSearchType {
    ALL,
    /**
     * 案号
     */
    CASE_NO(Arrays.asList("case_no", "case_no.keyword")),
    /**
     * 书记员
     */
    COURT_CLERK(Arrays.asList("clerk")),
    /**
     * 法院名称
     */
    COURT_NAME(Arrays.asList("court_name")),
    /**
     * 本院认为（法院认为）
     */
    COURT_VIEW(Arrays.asList("court_view")),
    /**
     * 审理经过（包含原告诉称、被告辩称、审理查明）
     */
    FACT(Arrays.asList("fact")),
    /**
     * 法官
     */
    JUDGE(Arrays.asList("judge")),
    /**
     * 裁判结果
     */
    JUDGE_RESULT(Arrays.asList("judge_result")),
    /**
     * 当事人
     */
    PARTY_INFO(Arrays.asList("party_info")),
    /**
     * 标题
     */
    TITLE(Arrays.asList("title")),


    ;

    public static final Set<String> KEYWORD_FIELDS = new HashSet<String>(){{
        add("case_no.keyword");
    }};

    JudgmentDocumentsSearchType(List<String> fields) {
        this.fields = fields;
    }

    JudgmentDocumentsSearchType() {
    }

    private List<String> fields;

    public List<String> getFields() {
        return fields;
    }
}
