package com.winhc.phoenix.example;

import com.aliyun.odps.Instance;
import com.aliyun.odps.Odps;
import com.aliyun.odps.data.Record;
import com.aliyun.odps.task.SQLTask;
import com.fasterxml.jackson.databind.DeserializationFeature;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.winhc.phoenix.example.service.HbaseOperationService;
import lombok.extern.slf4j.Slf4j;
import org.apache.hadoop.hbase.TableName;
import org.apache.hadoop.hbase.client.Connection;
import org.apache.hadoop.hbase.client.Delete;
import org.apache.hadoop.hbase.client.Get;
import org.apache.hadoop.hbase.client.Table;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.List;
import java.util.stream.Collectors;

/**
 * @Author: XuJiakai
 * @Date: 2020/9/17 15:03
 * @Description:
 */
@Slf4j
@SpringBootTest
public class DeletedHbase {

    @Autowired
    Odps odps;
    @Autowired
   HbaseOperationService hbaseOperationService;

    @Autowired
    private Connection connection;
    private static final ObjectMapper objectMapper = new ObjectMapper()
            .configure(DeserializationFeature.ACCEPT_SINGLE_VALUE_AS_ARRAY, true);

    @Test
    public void run() {
        String sql = "select id from winhc_eci_dev.xjk_tmp_tmp_dy ;";
        try {
            Instance i = SQLTask.run(odps, sql);
            i.waitForSuccess();
            List<Record> records = SQLTask.getResult(i);
            List<Delete> deletes = records.stream().map(r -> {
                String id = r.getString("id");
                return new Delete(id.getBytes());
            }).collect(Collectors.toList());

            List<Get> gets = records.stream().map(r -> {
                String id = r.getString("id");
                return new Get(id.getBytes());
            }).collect(Collectors.toList());
            log.info("gets size:{}", gets.size());
            try (Table table = connection.getTable(TableName.valueOf("COMPANY_DYNAMIC"))) {

                log.info("deletes size:{}", deletes.size());
                table.delete(deletes);
                boolean[] exists = table.exists(gets);
                log.info("length:{}", exists.length);

               /* Result[] results = table.get(gets.subList(0,10));
                for (Result result : results) {
                    Map<String, Object> stringObjectMap = HbaseResultUtils.parseResult(result);
                    log.info(objectMapper.writerWithDefaultPrettyPrinter().writeValueAsString(stringObjectMap));
                }*/
            }
        } catch (Exception e) {
            log.error(e.getMessage(), e);
        }
    }

    @Test
    public void r(){
//       String r =  "3046318584_6a1af2b2759975d27be2e38d9a441edd";
//        hbaseOperationService.deleteByRowkey("COMPANY_ZXR_LIST", r);
    }
}
