package com.winhc.phoenix.example;

import com.alibaba.dcm.DnsCacheManipulator;
import com.alibaba.lindorm.client.core.utils.Bytes;
import lombok.extern.slf4j.Slf4j;
import org.apache.hadoop.hbase.TableName;
import org.apache.hadoop.hbase.client.*;
import org.apache.hadoop.hbase.filter.PageFilter;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;


/**
 * @Author: XuJiakai
 * @Date: 2020/6/9 13:39
 * @Description:
 */
@Slf4j
@SpringBootTest
public class HbaseTests {
    private static final byte[] family = Bytes.toBytes("F");

    @Autowired
    private Connection connection;

    @Test
    public void test() {
        DnsCacheManipulator.loadDnsCacheConfig();
        try (Table table = connection.getTable(TableName.valueOf("COMPANY_BRIEF_CANCEL_ANNOUNCEMENT_RESULT"))) {
            log.info("start");

            Scan scan = new Scan();
            scan.setRowPrefixFilter("2311871324_2664997_2500025".getBytes());
            PageFilter pageFilter = new PageFilter(10);
            scan.setFilter(pageFilter);
            ResultScanner scanner = table.getScanner(scan);
            List<String> list = new ArrayList<>();
            for (Result result : scanner) {
                list.add(new String(result.getRow()));
            }
            System.out.println(list);
            assert !list.isEmpty();
            scanner.close();
        } catch (IOException e) {
            log.error(e.getMessage(), e);
        }
    }
}
